#[derive(Default)]
pub struct PNext<P>(P);
#[derive(Default)]
pub struct P0;
pub type P1 = PNext<P0>;
pub type P2 = PNext<P1>;
pub type P3 = PNext<P2>;
pub type P4 = PNext<P3>;
pub type P5 = PNext<P4>;
pub type P6 = PNext<P5>;
pub type P7 = PNext<P6>;

pub trait Peano: Default {
    type Next: PeanoNonZero;
}

pub trait PeanoNonZero: Peano {
    type Prev: Peano;
}

impl Peano for P0 {
    type Next = P1;
}
impl<P: Peano> Peano for PNext<P> {
    type Next = PNext<PNext<P>>;
}
impl<P: Peano> PeanoNonZero for PNext<P> {
    type Prev = P;
}
